## srslte 18.06.1

=== CMakeLists.txt ===
#
# Copyright 2013-2017 Software Radio Systems Limited
#
# This file is part of srsLTE
#
# srsLTE is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
#
# srsLTE is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# A copy of the GNU Affero General Public License can be found in
# the LICENSE file in the top-level directory of this distribution
# and at http://www.gnu.org/licenses/.
#


########################################################################
# Prevent in-tree builds
########################################################################
if(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
    message(FATAL_ERROR "Prevented in-tree build. This is bad practice.")
endif(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})


########################################################################
# Project setup
########################################################################
cmake_minimum_required(VERSION 2.6)
project( SRSLTE )
message( STATUS "CMAKE_SYSTEM: " ${CMAKE_SYSTEM} )
message( STATUS "CMAKE_SYSTEM_PROCESSOR: " ${CMAKE_SYSTEM_PROCESSOR} )
message( STATUS "CMAKE_CXX_COMPILER: " ${CMAKE_CXX_COMPILER} )

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/modules")
include(SRSLTEVersion) #sets version information
include(SRSLTEPackage) #setup cpack

include(CTest)

configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/CTestCustom.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/CTestCustom.cmake"
    IMMEDIATE @ONLY)

if(NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE Release)
   message(STATUS "Build type not specified: defaulting to Release.")
endif(NOT CMAKE_BUILD_TYPE)
set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "")

# Generate CMake to include build information
configure_file(
  ${CMAKE_SOURCE_DIR}/cmake/modules/SRSLTEbuildinfo.cmake.in
  ${CMAKE_BINARY_DIR}/SRSLTEbuildinfo.cmake
)

########################################################################
# Options
########################################################################
option(ENABLE_SRSUE    "Build srsUE application"                  ON)
option(ENABLE_SRSENB   "Build srsENB application"                 ON)
option(ENABLE_SRSEPC   "Build srsEPC application"                 ON)
option(DISABLE_SIMD    "disable simd instructions"                OFF)

option(ENABLE_GUI      "Enable GUI (using srsGUI)"                ON)
option(ENABLE_BLADERF  "Enable BladeRF"                           ON)
option(ENABLE_SOAPYSDR "Enable SoapySDR"                          ON)

option(BUILD_STATIC    "Attempt to statically link external deps" OFF)
option(RPATH           "Enable RPATH"                             OFF)
option(ENABLE_ASAN     "Enable gcc address sanitizer"             OFF)

option(USE_LTE_RATES   "Use standard LTE sampling rates"          OFF)

set(GCC_ARCH native CACHE STRING "GCC compile for specific architecture.")


########################################################################
# Find dependencies
########################################################################

# Threads
find_package(Threads REQUIRED)

# FFT
find_package(MKL)
if(MKL_FOUND)
  include_directories(${MKL_INCLUDE_DIRS})
  link_directories(${MKL_LIBRARY_DIRS})
  set(FFT_LIBRARIES "${MKL_STATIC_LIBRARIES}") # Static by default
else(MKL_FOUND)
  find_package(FFTW3F REQUIRED)
  if(FFTW3F_FOUND)
    include_directories(${FFTW3F_INCLUDE_DIRS})
    link_directories(${FFTW3F_LIBRARY_DIRS})
    if(BUILD_STATIC)
      set(FFT_LIBRARIES "${FFTW3F_STATIC_LIBRARIES}")
    else(BUILD_STATIC)
      set(FFT_LIBRARIES "${FFTW3F_LIBRARIES}")
    endif(BUILD_STATIC)
    message(STATUS "FFT_LIBRARIES: " ${FFT_LIBRARIES})
  endif(FFTW3F_FOUND)
endif(MKL_FOUND)

# Crypto
find_package(Polarssl)
if (POLARSSL_FOUND)
  set(SEC_INCLUDE_DIRS "${POLARSSL_INCLUDE_DIRS}")
  if(BUILD_STATIC)
    set(SEC_LIBRARIES    "${POLARSSL_STATIC_LIBRARIES}")
  else(BUILD_STATIC)
    set(SEC_LIBRARIES    "${POLARSSL_LIBRARIES}")
  endif(BUILD_STATIC)
  add_definitions(-DHAVE_POLARSSL)
else(POLARSSL_FOUND)
  find_package(MbedTLS REQUIRED)
  if (MBEDTLS_FOUND)
    set(SEC_INCLUDE_DIRS "${MBEDTLS_INCLUDE_DIRS}")
    if(BUILD_STATIC)
      set(SEC_LIBRARIES    "${MBEDTLS_STATIC_LIBRARIES}")
    else(BUILD_STATIC)
      set(SEC_LIBRARIES    "${MBEDTLS_LIBRARIES}")
    endif(BUILD_STATIC)
    add_definitions(-DHAVE_MBEDTLS)
  else(MBEDTLS_FOUND)
    message(FATAL_ERROR "Either PolarSSL or mbedTLS are required to build srsLTE")
  endif (MBEDTLS_FOUND)
endif(POLARSSL_FOUND)

# Hard-SIM support
find_package(PCSCLite)
if (PCSCLITE_FOUND)
  message(STATUS "Building with PCSC support.")
  add_definitions(-DHAVE_PCSC)
  set(HAVE_PCSC TRUE)
  include_directories(${PCSCLITE_INCLUDE_DIR})
  #link_directories(${PCSCLITE_LIBRARIES})
endif (PCSCLITE_FOUND)

# UHD
find_package(UHD)
if(UHD_FOUND)
  include_directories(${UHD_INCLUDE_DIRS})
  link_directories(${UHD_LIBRARY_DIRS})
endif(UHD_FOUND)

# BladeRF
if(ENABLE_BLADERF)
  find_package(bladeRF)
  if(BLADERF_FOUND)
    include_directories(${BLADERF_INCLUDE_DIRS})
    link_directories(${BLADERF_LIBRARY_DIRS})
  endif(BLADERF_FOUND)
endif(ENABLE_BLADERF)

# Soapy
if(ENABLE_SOAPYSDR)
  find_package(SoapySDR)
  if(SOAPYSDR_FOUND)
    include_directories(${SOAPYSDR_INCLUDE_DIRS})
    link_directories(${SOAPYSDR_LIBRARY_DIRS})
  endif(SOAPYSDR_FOUND)
endif(ENABLE_SOAPYSDR)

if(BLADERF_FOUND OR UHD_FOUND OR SOAPYSDR_FOUND)
  set(RF_FOUND TRUE CACHE INTERNAL "RF frontend found")
else(BLADERF_FOUND OR UHD_FOUND OR SOAPYSDR_FOUND)
  set(RF_FOUND FALSE CACHE INTERNAL "RF frontend found")
  add_definitions(-DDISABLE_RF)
endif(BLADERF_FOUND OR UHD_FOUND OR SOAPYSDR_FOUND)

# Boost
if(ENABLE_SRSUE OR ENABLE_SRSENB OR ENABLE_SRSEPC)
  if(BUILD_STATIC)
    set(Boost_USE_STATIC_LIBS ON)
  endif(BUILD_STATIC)

  set(BOOST_REQUIRED_COMPONENTS
      program_options
  )
  if(UNIX AND EXISTS "/usr/lib64")
      list(APPEND BOOST_LIBRARYDIR "/usr/lib64") #fedora 64-bit fix
  endif(UNIX AND EXISTS "/usr/lib64")
  set(Boost_ADDITIONAL_VERSIONS
      "1.35.0" "1.35" "1.36.0" "1.36" "1.37.0" "1.37" "1.38.0" "1.38" "1.39.0" "1.39"
      "1.40.0" "1.40" "1.41.0" "1.41" "1.42.0" "1.42" "1.43.0" "1.43" "1.44.0" "1.44"
      "1.45.0" "1.45" "1.46.0" "1.46" "1.47.0" "1.47" "1.48.0" "1.48" "1.49.0" "1.49"
      "1.50.0" "1.50" "1.51.0" "1.51" "1.52.0" "1.52" "1.53.0" "1.53" "1.54.0" "1.54"
      "1.55.0" "1.55" "1.56.0" "1.56" "1.57.0" "1.57" "1.58.0" "1.58" "1.59.0" "1.59"
      "1.60.0" "1.60" "1.61.0" "1.61" "1.62.0" "1.62" "1.63.0" "1.63" "1.64.0" "1.64"
      "1.65.0" "1.65" "1.66.0" "1.66" "1.67.0" "1.67" "1.68.0" "1.68" "1.69.0" "1.69"
  )
  find_package(Boost "1.35" COMPONENTS ${BOOST_REQUIRED_COMPONENTS})
endif(ENABLE_SRSUE OR ENABLE_SRSENB OR ENABLE_SRSEPC)

# srsGUI
if(ENABLE_GUI)
  find_package(SRSGUI)
  if(SRSGUI_FOUND)
    add_definitions(-DENABLE_GUI)
    include_directories(${SRSGUI_INCLUDE_DIRS})
    link_directories(${SRSGUI_LIBRARY_DIRS})
  endif(SRSGUI_FOUND)
endif(ENABLE_GUI)

########################################################################
# Install Dirs
########################################################################
if (NOT CMAKE_INSTALL_LIBDIR)
    include(GNUInstallDirs)
endif (NOT CMAKE_INSTALL_LIBDIR)

# Fall back to just "lib" if the item provided by GNUInstallDirs doesn't exist
if (NOT EXISTS "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
    message(STATUS "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR} does not exist. Defaulting install location to ${CMAKE_INSTALL_PREFIX}/lib.")
    set(CMAKE_INSTALL_LIBDIR lib)
endif()

set(RUNTIME_DIR bin)
set(LIBRARY_DIR ${CMAKE_INSTALL_LIBDIR})
set(INCLUDE_DIR include)
set(DOC_DIR "share/doc/${CPACK_PACKAGE_NAME}")
set(DATA_DIR share/${CPACK_PACKAGE_NAME})

# Auto-generate config install helper and mark for installation
configure_file(
        ${CMAKE_SOURCE_DIR}/cmake/modules/SRSLTE_install_configs.sh.in
        ${CMAKE_BINARY_DIR}/srslte_install_configs.sh
)
install(PROGRAMS ${CMAKE_BINARY_DIR}/srslte_install_configs.sh DESTINATION ${RUNTIME_DIR})

########################################################################
# Compiler specific setup
########################################################################
macro(ADD_CXX_COMPILER_FLAG_IF_AVAILABLE flag have)
    include(CheckCXXCompilerFlag)
    check_cxx_compiler_flag(${flag} ${have})
    if(${have})
        add_definitions(${flag})        
    endif(${have})
endmacro(ADD_CXX_COMPILER_FLAG_IF_AVAILABLE)

if(CMAKE_CXX_COMPILER_ID MATCHES "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=${GCC_ARCH} -Wall -Wno-comment -Wno-reorder -Wno-unused-but-set-variable -Wno-unused-variable -Wformat -Wmissing-field-initializers -Wtype-limits -std=c++03")

  find_package(SSE)
  if (HAVE_AVX2)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mfpmath=sse -mavx2 -DLV_HAVE_AVX2 -DLV_HAVE_AVX -DLV_HAVE_SSE")
  else (HAVE_AVX2)
    if(HAVE_AVX)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mfpmath=sse -mavx -DLV_HAVE_AVX -DLV_HAVE_SSE")
    elseif(HAVE_SSE)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mfpmath=sse -msse4.1 -DLV_HAVE_SSE")
    endif(HAVE_AVX)
  endif (HAVE_AVX2)
endif(CMAKE_CXX_COMPILER_ID MATCHES "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")

ADD_CXX_COMPILER_FLAG_IF_AVAILABLE("-Werror=incompatible-pointer-types" HAVE_ERROR_INCOMPATIBLE)

if(CMAKE_C_COMPILER_ID MATCHES "GNU" OR CMAKE_C_COMPILER_ID MATCHES "Clang")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -march=${GCC_ARCH} -Wall -Wno-comment -Wno-write-strings -Winline -Wno-unused-result -Wformat -Wmissing-field-initializers -Wtype-limits -std=c99 -D_GNU_SOURCE")

  if(${CMAKE_BUILD_TYPE} STREQUAL "Debug")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ggdb -O0 -DDEBUG_MODE -DBUILD_TYPE_DEBUG")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ggdb -O0 -DDEBUG_MODE -DBUILD_TYPE_DEBUG")
  else(${CMAKE_BUILD_TYPE} STREQUAL "Debug")
    if(${CMAKE_BUILD_TYPE} STREQUAL "RelWithDebInfo")
      set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ggdb -DBUILD_TYPE_RELWITHDEBINFO")
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ggdb -DBUILD_TYPE_RELWITHDEBINFO")
    else(${CMAKE_BUILD_TYPE} STREQUAL "RelWithDebInfo")
      set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O3 -DBUILD_TYPE_RELEASE")
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -DBUILD_TYPE_RELEASE")
    endif(${CMAKE_BUILD_TYPE} STREQUAL "RelWithDebInfo")
  endif(${CMAKE_BUILD_TYPE} STREQUAL "Debug")

  if (USE_LTE_RATES)
    message(STATUS "Using standard LTE sampling rates")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DFORCE_STANDARD_RATE")
  endif (USE_LTE_RATES)

  find_package(SSE)
  if (HAVE_AVX2)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mfpmath=sse -mavx2 -DLV_HAVE_AVX2 -DLV_HAVE_AVX -DLV_HAVE_SSE")
  else (HAVE_AVX2)
    if(HAVE_AVX)
      set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mfpmath=sse -mavx -DLV_HAVE_AVX -DLV_HAVE_SSE")
    elseif(HAVE_SSE)
      set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mfpmath=sse -msse4.1 -DLV_HAVE_SSE")
    endif(HAVE_AVX)
  endif (HAVE_AVX2)

  if (HAVE_FMA)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mfma -DLV_HAVE_FMA")
  endif (HAVE_FMA)

  if (HAVE_AVX512)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mavx512f -mavx512cd -DLV_HAVE_AVX512")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mavx512f -mavx512cd -DLV_HAVE_AVX512")
  endif(HAVE_AVX512)

  if(NOT ${CMAKE_BUILD_TYPE} STREQUAL "Debug")
    if(HAVE_SSE)
      set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Ofast -funroll-loops")
    endif(HAVE_SSE)
  endif(NOT ${CMAKE_BUILD_TYPE} STREQUAL "Debug")

  
  if(${CMAKE_SYSTEM_PROCESSOR} MATCHES "arm")
    set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -mfpu=neon -march=native -DIS_ARM -DHAVE_NEON")

=== srsenb/CMakeLists.txt ===
#
# Copyright 2013-2017 Software Radio Systems Limited
#
# This file is part of srsLTE
#
# srsLTE is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
#
# srsLTE is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# A copy of the GNU Affero General Public License can be found in
# the LICENSE file in the top-level directory of this distribution
# and at http://www.gnu.org/licenses/.
#

find_package(LibConfig REQUIRED)
find_package(SCTP REQUIRED)

if(BUILD_STATIC)
  set(LIBCONFIGPP_LIBRARIES "${LIBCONFIGPP_STATIC_LIBRARY_PATH}")
endif(BUILD_STATIC)

if(NOT Boost_FOUND)
    message(FATAL_ERROR "Boost required to compile srsENB")
endif()

########################################################################
# Setup the include and linker paths
########################################################################
include_directories(
    ${Boost_INCLUDE_DIRS}
    ${SEC_INCLUDE_DIRS}
    ${PROJECT_SOURCE_DIR}
)

link_directories(
    ${Boost_LIBRARY_DIRS}
    ${SEC_LIBRARY_DIRS}
)

########################################################################
# Add subdirectories
########################################################################
add_subdirectory(src)
add_subdirectory(test)

########################################################################
# Default configuration files
########################################################################
install(FILES enb.conf.example DESTINATION ${DATA_DIR})
install(FILES drb.conf.example DESTINATION ${DATA_DIR})
install(FILES rr.conf.example DESTINATION ${DATA_DIR})
install(FILES sib.conf.example DESTINATION ${DATA_DIR})

=== srsepc/CMakeLists.txt ===
#
# Copyright 2013-2017 Software Radio Systems Limited
#
# This file is part of srsLTE
#
# srsLTE is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
#
# srsLTE is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# A copy of the GNU Affero General Public License can be found in
# the LICENSE file in the top-level directory of this distribution
# and at http://www.gnu.org/licenses/.
#

find_package(LibConfig REQUIRED)
find_package(SCTP REQUIRED)

if(BUILD_STATIC)
  set(LIBCONFIGPP_LIBRARIES "${LIBCONFIGPP_STATIC_LIBRARY_PATH}")
endif(BUILD_STATIC)

if(NOT Boost_FOUND)
    message(FATAL_ERROR "Boost required to compile srsEPC")
endif()

########################################################################
# Setup the include and linker paths
########################################################################
include_directories(
    ${Boost_INCLUDE_DIRS}
    ${SEC_INCLUDE_DIRS}
    ${PROJECT_SOURCE_DIR}
)

link_directories(
    ${Boost_LIBRARY_DIRS}
    ${SEC_LIBRARY_DIRS}
)

########################################################################
# Add subdirectories
########################################################################
add_subdirectory(src)

########################################################################
# Default configuration files
########################################################################
install(FILES epc.conf.example DESTINATION ${DATA_DIR})
install(FILES mbms.conf.example DESTINATION ${DATA_DIR})
install(FILES user_db.csv.example DESTINATION ${DATA_DIR})
install(PROGRAMS srsepc_if_masq.sh DESTINATION ${RUNTIME_DIR})

=== srsue/CMakeLists.txt ===
#
# Copyright 2013-2017 Software Radio Systems Limited
#
# This file is part of srsLTE
#
# srsLTE is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
#
# srsLTE is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# A copy of the GNU Affero General Public License can be found in
# the LICENSE file in the top-level directory of this distribution
# and at http://www.gnu.org/licenses/.
#

########################################################################
# Boost is required 
########################################################################
if(NOT Boost_FOUND)
    message(FATAL_ERROR "Boost required to compile srsUE and ")
endif()

########################################################################
# Setup the include and linker paths
########################################################################
include_directories(
    ${Boost_INCLUDE_DIRS}
    ${SEC_INCLUDE_DIRS}
    ${PROJECT_SOURCE_DIR}
)

link_directories(
    ${Boost_LIBRARY_DIRS}
    ${SEC_LIBRARY_DIRS}
)

########################################################################
# Add subdirectories
########################################################################
add_subdirectory(src)
add_subdirectory(test)

########################################################################
# Default configuration files
########################################################################
install(FILES ue.conf.example DESTINATION ${DATA_DIR})

=== lib/examples/CMakeLists.txt ===
#
# Copyright 2013-2017 Software Radio Systems Limited
#
# This file is part of srsLTE
#
# srsLTE is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
#
# srsLTE is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# A copy of the GNU Affero General Public License can be found in
# the LICENSE file in the top-level directory of this distribution
# and at http://www.gnu.org/licenses/.
#


#################################################################
# Applications
#################################################################

add_executable(synch_file synch_file.c)
target_link_libraries(synch_file srslte_phy)

#################################################################
# These can be compiled without UHD or graphics support
#################################################################

if(RF_FOUND)
  add_executable(pdsch_ue pdsch_ue.c)
  target_link_libraries(pdsch_ue srslte_phy srslte_common srslte_rf pthread)

  add_executable(pdsch_enodeb pdsch_enodeb.c)
  target_link_libraries(pdsch_enodeb srslte_phy srslte_common srslte_rf pthread)
else(RF_FOUND)
  add_definitions(-DDISABLE_RF)

  add_executable(pdsch_ue pdsch_ue.c)
  target_link_libraries(pdsch_ue srslte_common srslte_phy pthread)

  add_executable(pdsch_enodeb pdsch_enodeb.c)
  target_link_libraries(pdsch_enodeb srslte_common srslte_phy pthread)
endif(RF_FOUND)

find_package(SRSGUI)

if(SRSGUI_FOUND)
  include_directories(${SRSGUI_INCLUDE_DIRS})
  target_link_libraries(pdsch_ue ${SRSGUI_LIBRARIES})
else(SRSGUI_FOUND)
  add_definitions(-DDISABLE_GRAPHICS)
endif(SRSGUI_FOUND)


#################################################################
# These examples need the UHD driver
#################################################################

if(RF_FOUND)

  add_executable(cell_search cell_search.c)
  target_link_libraries(cell_search srslte_phy srslte_rf)

  add_executable(cell_measurement cell_measurement.c)
  target_link_libraries(cell_measurement srslte_phy srslte_rf)

  add_executable(usrp_capture usrp_capture.c)
  target_link_libraries(usrp_capture srslte_phy srslte_rf)

  add_executable(usrp_capture_sync usrp_capture_sync.c)
  target_link_libraries(usrp_capture_sync srslte_phy srslte_rf)

  add_executable(usrp_txrx usrp_txrx.c)
  target_link_libraries(usrp_txrx srslte_phy srslte_rf)

  message(STATUS "   examples will be installed.")

else(RF_FOUND)
  message(STATUS "   examples will NOT BE INSTALLED.")
endif(RF_FOUND)

=== lib/include/CMakeLists.txt ===
#
# Copyright 2013-2017 Software Radio Systems Limited
#
# This file is part of srsLTE
#
# srsLTE is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
#
# srsLTE is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# A copy of the GNU Affero General Public License can be found in
# the LICENSE file in the top-level directory of this distribution
# and at http://www.gnu.org/licenses/.
#

########################################################################
# Add subdirectories
########################################################################
add_subdirectory(srslte)

=== lib/src/CMakeLists.txt ===
#
# Copyright 2013-2017 Software Radio Systems Limited
#
# This file is part of srsLTE
#
# srsLTE is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
#
# srsLTE is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# A copy of the GNU Affero General Public License can be found in
# the LICENSE file in the top-level directory of this distribution
# and at http://www.gnu.org/licenses/.
#

add_subdirectory(asn1)
add_subdirectory(common)
add_subdirectory(phy)
add_subdirectory(radio)
add_subdirectory(upper)

=== lib/test/CMakeLists.txt ===
#
# Copyright 2013-2017 Software Radio Systems Limited
#
# This file is part of srsLTE
#
# srsLTE is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
#
# srsLTE is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# A copy of the GNU Affero General Public License can be found in
# the LICENSE file in the top-level directory of this distribution
# and at http://www.gnu.org/licenses/.
#

add_subdirectory(asn1)
add_subdirectory(common)
add_subdirectory(phy)
add_subdirectory(upper)

=== srsenb/hdr/CMakeLists.txt ===

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/version.h.in
    ${PROJECT_BINARY_DIR}/version.h
)

=== srsenb/test/CMakeLists.txt ===

add_subdirectory(mac)
add_subdirectory(upper)

=== srsepc/hdr/CMakeLists.txt ===
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/version.h.in
    ${PROJECT_BINARY_DIR}/version.h
)

=== srsue/src/CMakeLists.txt ===
#
# Copyright 2013-2017 Software Radio Systems Limited
#
# This file is part of srsLTE
#
# srsLTE is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
#
# srsLTE is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# A copy of the GNU Affero General Public License can be found in
# the LICENSE file in the top-level directory of this distribution
# and at http://www.gnu.org/licenses/.
#

add_subdirectory(phy)
add_subdirectory(mac)
add_subdirectory(upper)

# Link libstdc++ and libgcc
if(BUILD_STATIC)
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static-libstdc++ -static-libgcc")
endif(BUILD_STATIC)

if (RPATH)
  set(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
endif (RPATH)

add_executable(srsue main.cc ue_base.cc ue.cc metrics_stdout.cc metrics_csv.cc)
target_link_libraries(srsue   srsue_mac
                              srsue_phy
                              srsue_upper
                              srslte_common
                              srslte_phy
                              srslte_upper
                              srslte_radio
                              ${CMAKE_THREAD_LIBS_INIT}
                              ${Boost_LIBRARIES})

if (RPATH)
  set_target_properties(srsue PROPERTIES INSTALL_RPATH ".")
endif (RPATH)

install(TARGETS srsue DESTINATION ${RUNTIME_DIR})

########################################################################
# Option to run command after build (useful for remote builds)
########################################################################
if (NOT ${BUILDUE_CMD} STREQUAL "")
  message(STATUS "Added custom post-build-UE command: ${BUILDUE_CMD}")
  add_custom_command(TARGET srsue POST_BUILD COMMAND ${BUILDUE_CMD})
else(NOT ${BUILDUE_CMD} STREQUAL "")
  message(STATUS "No post-build-UE command defined")
endif (NOT ${BUILDUE_CMD} STREQUAL "")

install(TARGETS srsue DESTINATION ${RUNTIME_DIR})

=== debian/changelog ===
srslte (18.06.1-9build1) hirsute; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 12 Dec 2020 13:20:22 +0100

srslte (18.06.1-9) unstable; urgency=medium

  [ Peter Michael Green ]
  * Add patches to fix build with libbladerf2 and uhd 3.14 (Closes: #940131)
  * Bump build-dependencies on libbladerf-dev and libuhd-dev
    because aforementioned patches will break build with
    older versions.

  [ Ruben Undheim ]
  * Thanks Peter Michael Green !
  * Use debhelper-compat
  * Set DH level to 12
  * New standards version 4.5.0 - no changes

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sun, 22 Mar 2020 10:05:35 +0100

srslte (18.06.1-8) unstable; urgency=medium

  * debian/rules:
    - Only run test suite on some architectures
  * debian/srsepc.install:
    - Also install /usr/bin/srsmbms in 'srsepc'

 -- Ruben Undheim <ruben.undheim@gmail.com>  Mon, 03 Dec 2018 19:21:47 +0100

srslte (18.06.1-7) unstable; urgency=medium

  * Split srslte into multiple binary packages since there are several
    daemons:
    - srsenb
    - srsue
    - srsepc
    - srslte-core
  * srslte-dev depends on srslte-core:any
  * srslte binary package changed to arch=all and binNMU-safe dependencies
    added
  * Move man pages to section 8.
  * debian/rules:
    - Change override_dh_install to override_dh_install-arch
    - Separate build targets for -indep and -arch to make all-build faster
    - Enable test suite for non-SIMD builds

 -- Ruben Undheim <ruben.undheim@gmail.com>  Wed, 28 Nov 2018 19:48:50 +0100

srslte (18.06.1-6) unstable; urgency=medium

  * debian/control:
    - srslte-dev set to "Multi-Arch: same"
    - srslte set to "Multi-Arch: allowed"
    - Dependency on srslte for srslte-dev changed to "srslte:any"
  * debian/rules:
    - Include FMA extension for AVX2 build
    - Clean up properly in override_dh_auto_clean
    - Tidy up commands a bit
    - Disable build of Neon for ARM since it fails to build from source
    - Workaround to get custom cmake invocations to pick up hardening flags
  * d/patches/0007-Option-for-disabling-NEON-on-arm.patch:
    - Fix typo in patch
  * debian/script/srsenb: Start command with "exec"
  * debian/script/srsue: Start command with "exec"
  * debian/tests:
    - Added autopkgtest for srslte checking that all the commands can run

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sat, 24 Nov 2018 10:58:57 +0100

srslte (18.06.1-5) unstable; urgency=medium

  * debian/control:
    - Added more build-dependencies
  * debian/rules:
    - Build separate executables for CPUs with AVX2 extensions, and CPUs
      with SSE4.2 but no AVX extension.
    - Print which version is chosen when starting.
    - Add '-q' to grep invocation

 -- Ruben Undheim <ruben.undheim@gmail.com>  Fri, 23 Nov 2018 18:35:40 +0100

srslte (18.06.1-4) unstable; urgency=medium

  * debian/rules:
    - Build one version with AVX SIMD support for Intel CPUs and one version
      with NEON SIMD support for Arm CPUs.
  * debian/script/srsenb and debian/script/srsue:
    - Scripts which first check if avx2 or neon is available on the machine
      before choosing which executable to start.
  * Restructured patches a bit:
    - 0004-Disable-architecture-specific-SIMD-optimisations.patch removed
    - New patches:
      - 0005-Check-whether-code-compiles-instead-of-whether-it-ru.patch
      - 0005-Patch-for-setting-custom-RPATH.patch
      - 0006-No-native-in-build.patch
      - 0007-Option-for-disabling-NEON-on-arm.patch

 -- Ruben Undheim <ruben.undheim@gmail.com>  Fri, 23 Nov 2018 08:55:21 +0100

srslte (18.06.1-3) unstable; urgency=medium

  * Install systemd service files for the 3 services:
    - srsenb.service
    - srsue.service
    - srsepc.service
  * Install default configuration in /etc/srslte/:
    - drb.conf
    - enb.conf
    - epc.conf
    - mbms.conf
    - rr.conf
    - sib.conf
    - ue.conf
    - user_db.csv
  * debian/rules:
    - Do not enable or start services by default

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sun, 18 Nov 2018 10:52:08 +0100

srslte (18.06.1-2) unstable; urgency=medium

  * d/patches/0004-Disable-architecture-specific-SIMD-optimisations.patch
    - For fixing FTBFS on multiple architectures

 -- Ruben Undheim <ruben.undheim@gmail.com>  Fri, 05 Oct 2018 00:45:17 +0200

srslte (18.06.1-1) unstable; urgency=low

  * Initial release (Closes: #904221)

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sun, 02 Sep 2018 22:56:55 +0200

=== debian/control ===
Source: srslte
Section: net
Priority: optional
Maintainer: Debian Mobcom Maintainers <Debian-mobcom-maintainers@lists.alioth.debian.org>
Uploaders: Ruben Undheim <ruben.undheim@gmail.com>
Build-Depends: debhelper-compat (= 12),
               cmake,
               libfftw3-dev,
               libmbedtls-dev,
               libboost-program-options-dev,
               libconfig++-dev,
               libsctp-dev,
               libuhd-dev (>= 3.14),
               uhd-host,
               txt2man,
               libpcsclite-dev,
               libbladerf-dev (>= 0.2019.07),
               libsoapysdr-dev
Standards-Version: 4.5.0
Homepage: http://www.softwareradiosystems.com
Vcs-Git: https://salsa.debian.org/debian-mobcom-team/srslte.git
Vcs-Browser: https://salsa.debian.org/debian-mobcom-team/srslte

Package: srslte-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         srslte-core:any (= ${binary:Version})
Description: Static libraries and headers for srslte
 This software allows you to run a full end-to-end, open-source LTE system.
 It contains a UE, eNB and EPC implementation.
 .
 This package contains the development files - static libraries and headers

Package: srslte
Architecture: all
Depends: ${shlibs:Depends},
         ${misc:Depends},
         srsenb       (>= ${source:Version}), srsenb (<< ${source:Upstream-Version}.0~),
         srsue        (>= ${source:Version}), srsue  (<< ${source:Upstream-Version}.0~),
         srsepc       (>= ${source:Version}), srsepc (<< ${source:Upstream-Version}.0~)
Suggests: nextepc
Description: LTE software suite for software defined radios (metapackage)
 This software enables running a full end-to-end, open-source LTE system. It
 contains a UE, eNB and EPC implementation.
 .
 For running a full network, also an implementation of the Evolved Packet Core
 (EPC) is needed.

Package: srsenb
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         srslte-core (= ${binary:Version})
Suggests: nextepc
Breaks: srslte (<< 18.06.1-7)
Replaces: srslte (<< 18.06.1-7)
Description: Evolved Node B in LTE network for Software Defined Radios
 This software enables running a "base-station" for an LTE network.
 .
 For running a full network, also an implementation of the Evolved Packet Core
 (EPC) is needed. (such as nextepc)
 .
 It contains the evolved Node B (eNB) component of the network.

Package: srsue
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         srslte-core (= ${binary:Version})
Breaks: srslte (<< 18.06.1-7)
Replaces: srslte (<< 18.06.1-7)
Description: User Equipment implementation for LTE
 This software enables using a software defined radio as the user equipment
 connecting to an LTE network.
 .
 srsue provides a complete SDR LTE UE application featuring all layers from PHY
 to IP.
 .
 For running an LTE network, 'srsenb' should be used instead.

Package: srsepc
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         srslte-core (= ${binary:Version})
Recommends: srsenb
Breaks: srslte (<< 18.06.1-7)
Replaces: srslte (<< 18.06.1-7)
Description: Light-weight LTE core network implementation
 Together with 'srsenb', this software opens up the possibility to run an LTE
 network using a software defined radio.
 .
 It is a lightweight alternative to tools such as nextepc.

Package: srslte-core
Architecture: any
Multi-Arch: allowed
Depends: ${shlibs:Depends},
         ${misc:Depends}
Breaks: srslte (<< 18.06.1-7)
Replaces: srslte (<< 18.06.1-7)
Description: Common files for srsLTE
 This software enables running a full end-to-end, open-source LTE system. It
 contains a UE, eNB and EPC implementation.
 .
 For running a full network, also an implementation of the Evolved Packet Core
 (EPC) is needed.
 .
 This package contains the common files for srsenb, srsue and srsepc.

=== debian/tests/control ===
Tests: srsenb-help, srsue-help, srsepc-help
Depends: srslte
